---
title: Use Cases
weight: 2
description: The golden paths in the engineers and product development domain
---

## Rationale 

The challenge of IPCEI-CIS Developer Framework is to provide value for DTAG customers, and more specifically: for Developers of DTAG customers.

That's why we need verifications - or test use cases - for the Developer Framework to develop.

![alt text](platforms-def.drawio.png)
(source: https://tag-app-delivery.cncf.io/whitepapers/platforms/)

## Golden Paths as Use Cases

* https://platformengineering.org/blog/how-to-pave-golden-paths-that-actually-go-somewhere
* https://thenewstack.io/using-an-internal-developer-portal-for-golden-paths/
* https://nl.devoteam.com/expert-view/building-golden-paths-with-internal-developer-platforms/
* https://www.redhat.com/en/blog/designing-golden-paths

## List of Use Cases

Here we have a collection of possible usage scenarios.

### Socksshop

Deploy and develop the famous socks shops:

* https://medium.com/@wadecharley703/socks-shop-microservices-application-deployment-on-the-cloud-cd1017cce1c0

* See also mkdev fork: https://github.com/mkdev-me/microservices-demo

### Humanitec Demos

* https://github.com/poc-template-org/node-js-sample

### Github Examples

* https://github.com/kezoo/nestjs-reactjs-graphql-typescript-boilerplate-example

### Telemetry Use Case with respect to the Fibonacci workload

The Fibonacci App on the cluster can be accessed on the path https://cnoe.localtest.me/fibonacci.
It can be called for example by using the URL https://cnoe.localtest.me/fibonacci?number=5000000.

The resulting ressource spike can be observed one the Grafana dashboard "Kubernetes / Compute Resources / Cluster".
The resulting visualization should look similar like this:


![alt text](fibonacci-app_cpu-spike.png)



## When and how to use the developer framework?

### e.g. an example

.... taken from https://cloud.google.com/blog/products/application-development/common-myths-about-platform-engineering?hl=en

![alt text](image.png)