---
title: List of references
weight: 10
linktitle: References
description: An currently uncurated list of references with respect to typical platform building components
---

## CNCF

> [Here are capability domains to consider when building platforms for cloud-native computing](https://tag-app-delivery.cncf.io/whitepapers/platforms/#capabilities-of-platforms):

* Web portals for observing and provisioning products and capabilities
* APIs (and CLIs) for automatically provisioning products and capabilities
* “Golden path” templates and docs enabling optimal use of capabilities in products
* Automation for building and testing services and products
* Automation for delivering and verifying services and products
* Development environments such as hosted IDEs and remote connection tools
* Observability for services and products using instrumentation and dashboards, including observation of functionality, performance and costs
* Infrastructure services including compute runtimes, programmable networks, and block and volume storage
* Data services including databases, caches, and object stores
* Messaging and event services including brokers, queues, and event fabrics
* Identity and secret management services such as service and user identity and authorization, certificate and key issuance, and static secret storage
* Security services including static analysis of code and artifacts, runtime analysis, and policy enforcement
* Artifact storage including storage of container image and language-specific packages, custom binaries and libraries, and source code

## IDP

> [An Internal Developer Platform (IDP) should be built to cover 5 Core Components:](https://internaldeveloperplatform.org/core-components/)

| Core Component | Short Description |
| ---- | --- |
| Application Configuration Management |	Manage application configuration in a dynamic, scalable and reliable way. |
| Infrastructure Orchestration |	Orchestrate your infrastructure in a dynamic and intelligent way depending on the context. |
| Environment Management |	Enable developers to create new and fully provisioned environments whenever needed. |
| Deployment Management |	Implement a delivery pipeline for Continuous Delivery or even Continuous Deployment (CD). |
| Role-Based Access Control |	Manage who can do what in a scalable way. |