+++
archetype = "sub-chapter"
title = "Reference Architecture"
weight = 1
[params]
    author = 'stephan.lo@telekom.de'
    date = '2024-07-30'
+++

##  [The Structure of a Successful Internal Developer Platform](https://platformengineering.org/blog/create-your-own-platform-engineering-reference-architectures)

In a platform reference architecture there are five main planes that make up an IDP:

1. Developer Control Plane – this is the primary configuration layer and interaction point for the platform users. Components include Workload specifications such as Score and a portal for developers to interact with.
2. Integration and Delivery Plane – this plane is about building and storing the image, creating app and infra configs, and deploying the final state. It usually contains a CI pipeline, an image registry, a Platform Orchestrator, and the CD system.
3. Resource Plane – this is where the actual infrastructure exists including clusters, databases, storage or DNS services.
4, Monitoring and Logging Plane – provides real-time metrics and logs for apps and infrastructure. 
5. Security Plane – manages secrets and identity to protect sensitive information, e.g., storing, managing, and security retrieving API keys and credentials/secrets.

![idp](../idp.webp)

(source: https://humanitec.com/blog/wtf-internal-developer-platform-vs-internal-developer-portal-vs-paas)


## Humanitec

https://github.com/humanitec-architecture

https://humanitec.com/reference-architectures



## Create a reference architecture

[Create your own platform reference architecture](https://platformengineering.org/blog/create-your-own-platform-engineering-reference-architectures)

[Reference arch slide deck](https://docs.google.com/presentation/d/1yAf_FSjiA0bAFukgu5p1DRMvvGGE1fF4KhvZbb7gn2I/edit?pli=1#slide=id.g1ef66f3349b_3_3)



