# Backstage

Backstage is a Platform Portal for building and managing internal developer tools, providing a unified interface for accessing various tools and resources within an organization.

---

## Key features of Backstage as a Platform Portal

### 🤝 Tool Integration

Backstage allows for the integration of various tools used in the development process, such as CI/CD, version control systems, monitoring, and others, into a single interface.

### 🏗️ Service Management

It offers the ability to register and manage services and microservices, as well as monitor their status and performance.

### 📚 Documentation and Learning Materials

Backstage includes capabilities for storing and organizing documentation, making it easier for developers to access information.

### 🌟 Golden Paths

Backstage supports the concept of "Golden Paths," enabling teams to follow recommended practices for development and tool usage.

### 🧩 Modularity and Extensibility

The platform allows for the creation of plugins, enabling users to customize and extend Backstage's functionality to fit their organization's needs.
Backstage provides developers with centralized and convenient access to essential tools and resources, making it an effective solution for supporting Platform Engineering and developing an internal platform portal.

---

## How to use Backstage templates (Golden Paths) in EDP

1. **Open the Backstage**
LINK

2. **Navigate to "Create"**

   In the left-hand menu, click on the "Create" option. This will open a page with available component templates.
   ![step 2](../ressources/1.png)

3. **Select a template**

   Choose the template that suits your needs. For example, the "Spring PetClinic Template" may be shown in screenshots.

4. **Fill out the required fields**

   Enter the necessary information that the template requires to create the component.
   ![step 2](../ressources/2.png)

5. **Monitor the template execution**

   After submission, you will be redirected to a page showing the status of each step. If all steps are completed successfully, your component is ready for use.
   ![step 2](../ressources/3.png)

---

## 🔗 References

* [Backstage Documentation & Community](https://backstage.io/)
* [Backstage's GitHub](https://github.com/backstage/backstage)