# Forgejo

In our EDP, we utilize Forgejo for Git hosting, Forgejo Registry for container image storage, and Forgejo Runner for [continuous integration (CI) workflows](ci-workflow.md). Here's a brief overview of these components and their roles.

---

## Features

**Forgejo** is a Git server that provides version control for your code repositories. It offers:

- **💾 Code Hosting:** Store and manage your source code repositories.
- **👥 Collaboration Tools:** Features like pull requests, issue tracking, and code reviews to enhance teamwork.
- **✅ Git Actions:** Native support for CI/CD workflows using Forgejo Actions.

Forgejo serves as the central hub for managing source code and related development activities.

---

## Forgejo Registry

**Forgejo Registry** is a container image registry integrated with Forgejo. It allows you to:

- **🐳 Store Docker Images**: Save and manage container images for deployment.
- **📜 Version Control**: Keep track of different versions of your container images.
- **⚙️ Integration with CI Workflows**: Store images built by CI workflows for future deployment.

The Forgejo Registry simplifies the process of managing container images and ensures they are readily available for deployment.

---

## Forgejo Runner

**Forgejo Runner** is a tool used to execute CI/CD workflows defined in Forgejo Actions. It provides:

- **▶️ Pipeline Execution**: Runs automated tasks such as building, testing, and deploying code.
- **⚙️ Integration with Forgejo**: Seamless execution of workflows hosted on the Forgejo Git server.
- **⚒️ Image Building**: Builds Docker images and pushes them to the Forgejo Registry.

Forgejo Runner ensures that your CI/CD processes run smoothly and consistently.

---

## 🔗 References

- [Forgejo Documentation & Community](https://forgejo.org/)
- [Forgejo Runner Guildes & Documentation](https://forgejo.org/docs/latest/admin/runner-installation/)
- [Forgejo Runner's Repository](https://code.forgejo.org/forgejo/runner)
